local blood = {}
local splats = {}

local trailTime = 0.01 --0.01
local trailMaxLength = 30

function num_bloods()
	return #blood
end

function get_blood(i)
	return blood[i].x, blood[i].y - blood[i].z, #blood[i].trail/trailMaxLength, blood[i].collectible
end

function add_splat(x,y,size)
	local s = {}
	s.x = x
	s.y = y
	s.screenSize = 0.5
	s.size = size
	table.insert(splats, s)
end

function add_blood(x,y,amount,angle)
	--amount = amount * 2
	for i=1,amount do
		local b = {}
		b.scale = 1
		local f = math.random(100,180)
		f = math.random(50,250)		

		b.collectible = true
		local a = math.random(angle*100+50, angle*100-50)/100
		if(i%3 == 1 or i%3 == 2) then
			b.collectible = false
			a = math.random(angle*100+100, angle*100-100)/100 + math.pi -- math.random(0, 2*math.pi*100)/100
			b.scale = math.random(50,125)/100
		end

		if(b.collectible) then
			f = f * 1.5
		end
		
		b.x = x + math.random(-10,10)
		b.y = y + math.random(-10,10)
		b.z = 40
		b.xvel = math.cos(a) * f
		b.yvel = math.sin(a) * f
		b.zvel = math.random(50,250)
		b.angle = angle
		b.a = angle
		b.size = math.random(10,20)/10
		b.trail = {}
		b.trailTimer = 0
		b.toRemove = false
		b.lifetime = 0
		b.count = 0
		table.insert(blood,b)
	end
end

local gravity = 750
local spinRange = 400



function blood_update(dt)
	if(get_slowmo() > 0) then
		dt = dt * 10
	end
	for i,v in ipairs(blood) do


		if(get_slowmo() > 0) then
			v.lifetime = math.min(1, v.lifetime + 2 * dt )
			--trailMaxLength = trailMaxLength 
		else
			v.lifetime = math.min(1, v.lifetime + 2 * dt)
		end
		-- trail
		v.trailTimer = v.trailTimer - dt
		if(v.trailTimer < 0) then
			if(#v.trail == 0) then
				v.trail[1] = {x=v.x, y=v.y-v.z}
			else
				if(v.toRemove == true) then
					if(#v.trail == 1) then
						--add_orb(v.x,v.y,{1,0.5,0.5},1)
						table.remove(blood, i)
						
					else
						table.remove(v.trail,#v.trail)
					end
				else
					v.count = v.count + 1
					for j=#v.trail + 1, 1, -1 do
						if(j == 1) then
							v.trail[j] = {x=v.x, y=v.y-v.z}
							--v.trail[j] = {x=v.x + math.sin(v.count) * 3, y=v.y-v.z + math.sin(v.count) * 3}
						elseif(j > #v.trail) then
							if(#v.trail < trailMaxLength) then
								v.trail[j] = {}
								v.trail[j].x = v.trail[j-1].x
								v.trail[j].y = v.trail[j-1].y
							end
						else
							v.trail[j].x = v.trail[j-1].x
							v.trail[j].y = v.trail[j-1].y			
						end

					end
				end
			end
		
			v.trailTimer = trailTime
		end
	
		if(v.toRemove == false) then
		
			if(v.xvel > 0) then
			
				if(v.zvel > 0) then
					v.a = math.min(spinRange, v.zvel)/spinRange * -math.pi/2
				else
					v.a = math.max(-spinRange, v.zvel)/-spinRange * math.pi/2
				end
			else
				if(v.zvel > 0) then
					v.a = math.min(spinRange, v.zvel)/spinRange * math.pi/2 + math.pi
				else
					v.a = math.max(-spinRange, v.zvel)/-spinRange * -math.pi/2 + math.pi
				end
			end
			
			
			if(get_slowmo() > 0) then
				v.zvel = v.zvel - gravity * dt * 0.75
				if(v.z + v.zvel * dt * 0.75 <= 0) then
					--play_sfx("splat",v.x,v.y)
					add_splat(v.x, v.y, v.size)
					v.z = 0
					v.zvel = -v.zvel * 0.5
					v.xvel = v.xvel * 0.5
					v.yvel = v.yvel * 0.5
					v.size = math.max(0.5,v.size * 0.75)
					if(v.zvel <= 150 or v.collectible == false) then
						v.zvel = 0
						v.xvel = 0
						v.yvel = 0
						
						v.toRemove = true
						--table.remove(blood,i)
					end
				end
			else
				v.zvel = v.zvel - gravity * dt
				if(v.z + v.zvel * dt <= 0) then
					--play_sfx("splat",v.x,v.y)
					add_splat(v.x, v.y, v.size)
					v.z = 0
					if(v.collectible) then
						v.zvel = -v.zvel * 0.75
					else
						v.zvel = -v.zvel * 0.5
					end
					v.xvel = v.xvel * 0.5
					v.yvel = v.yvel * 0.5
					v.size = math.max(0.5,v.size * 0.75)
					if(v.zvel <= 150 or v.collectible == false) then
						v.zvel = 0
						v.xvel = 0
						v.yvel = 0
						
						v.toRemove = true
						--table.remove(blood,i)
					end
				end
			end
			if(v.z + v.zvel * dt <= 0) then
				--play_sfx("splat",v.x,v.y)
				add_splat(v.x, v.y, v.size)
				v.z = 0
				v.zvel = -v.zvel * 0.5
				v.xvel = v.xvel * 0.5
				v.yvel = v.yvel * 0.5
				v.size = math.max(0.5,v.size * 0.75)
				if(v.zvel <= 150) then
					v.zvel = 0
					v.xvel = 0
					v.yvel = 0
					
					v.toRemove = true
					--table.remove(blood,i)
				end
			end

			v.x, v.y, v.xvel, v.yvel = world_bounceCol2(v.x, v.y, 6, 6, v.xvel, v.yvel, dt)

			if(get_slowmo() > 0) then
				v.x = v.x + v.xvel * dt * 0.5
				v.y = v.y + v.yvel * dt * 0.5
				v.z = v.z + v.zvel * dt	* 0.5	
			else
				v.x = v.x + v.xvel * dt
				v.y = v.y + v.yvel * dt
				v.z = v.z + v.zvel * dt
			end
		end
	end

	for i,v in ipairs(splats) do
		v.screenSize = math.min(v.size, v.screenSize + (v.size - v.screenSize) * dt)
		if(v.screenSize >= v.size - 0.1) then v.screenSize = v.size end
	end
end

local bloodImg = love.graphics.newImage("blood.png")
local splatImg = love.graphics.newImage("splat.png")

local trailWidth = 20

local smokeImg = love.graphics.newImage("smoke.png")
local glowImg = love.graphics.newImage("glow.png")

function blood_draw()
	for i,v in ipairs(blood) do
	
		if(on_screen(v.x,v.y, 10, 10)) then
			

			
			for j=1,#v.trail do
				if(v.collectible == true) then
					love.graphics.setColor(0.3,0,0,(1 - (j/#v.trail)) * 0.5)
					love.graphics.setColor(0.6,0.3,0,(1 - (j/#v.trail)) * 0.75)
					love.graphics.setLineWidth((#v.trail - j )* 0.25 * 0.75)
					--love.graphics.setLineWidth((1 - j/trailMaxLength)* 5)
					if(j==1) then
						love.graphics.line(v.trail[j].x, v.trail[j].y, v.x, v.y - v.z)
					else
						love.graphics.line(v.trail[j].x, v.trail[j].y, v.trail[j-1].x, v.trail[j-1].y)
					end
					--love.graphics.circle("fill", v.trail[j].x, v.trail[j].y, (#v.trail - j)/trailMaxLength * trailWidth)

				end
				
				if(v.collectible == false) then
					love.graphics.setColor(0.3 + 0.3 * j/#v.trail,0,0,(1 - (j/#v.trail)) * #v.trail/trailMaxLength * v.lifetime)
					love.graphics.setColor(0.5 + 0.3 * j/#v.trail,0,0,(1 - (j/#v.trail)) * #v.trail/trailMaxLength * v.lifetime)
					local size = ((trailMaxLength - j)/trailMaxLength * trailWidth) / smokeImg:getWidth() * 0.75 * v.scale
					if (j ~= 1) then size = size * 0.8  end				
					love.graphics.draw(smokeImg, v.trail[j].x, v.trail[j].y, j/2, size, size, smokeImg:getWidth()/2, smokeImg:getHeight()/2)
				end
				
				--add_drawable("blood", {img = smokeImg, x = v.trail[j].x, y = v.trail[j].y, 0 , sx = size, sy = size, ox = smokeImg:getWidth()/2, oy = smokeImg:getHeight()/2, height = v.y - v.trail[j].y, alpha = (1 - (j/#v.trail))*0.9})
			end
			love.graphics.setLineWidth(1)
			
			
			if(v.collectible and v.trail[1]) then

				love.graphics.setColor(0.75,0,0,#v.trail/trailMaxLength * 0.25)
				--love.graphics.draw(glowImg, v.trail[1].x, v.trail[1].y, 0, v.lifetime*0.5, v.lifetime*0.5, glowImg:getWidth()/2, glowImg:getWidth()/2)
				love.graphics.draw(glowImg, v.x, v.y - v.z, 0, #v.trail/trailMaxLength*0.5, #v.trail/trailMaxLength*0.5, glowImg:getWidth()/2, glowImg:getWidth()/2)
				love.graphics.setColor(0.75,0,0,#v.trail/trailMaxLength * 0.5)
				love.graphics.draw(smokeImg, v.x, v.y - v.z, 0, #v.trail/trailMaxLength*1, #v.trail/trailMaxLength*1, smokeImg:getWidth()/2, smokeImg:getWidth()/2)
				love.graphics.setColor(0.3,0,0,#v.trail/trailMaxLength)
				love.graphics.circle("fill", v.x, v.y - v.z, #v.trail * 0.25 * 0.5)
				
				love.graphics.setColor(0.6,0,0,#v.trail/trailMaxLength)
				love.graphics.circle("line", v.x, v.y - v.z, #v.trail * 0.25 * 0.5)				
				
				--love.graphics.setColor(1,165/255,0,0.5)
				--love.graphics.setColor(0,0,0.1)
				--love.graphics.draw(glowImg, v.x, v.y - v.z, 0, (#v.trail * 0.25) / glowImg:getWidth() * 1.25, (#v.trail * 0.25) / glowImg:getHeight() * 1.25, glowImg:getWidth()/2, glowImg:getHeight()/2)

			end			
			
			love.graphics.setColor(1,1,1)
			--add_drawable("img", {img = bloodImg, x = v.x, y = v.y - v.z, angle = v.a , sx = v.size, sy = v.size, ox = bloodImg:getWidth()/2, oy = bloodImg:getHeight()/2, height = v.z})
		end
		for i,v in ipairs(splats) do
			if(on_screen(v.x-5,v.y-5, 10, 10)) then
				--love.graphics.print(#splats,v.x,v.y)
				--love.graphics.draw(splatImg, v.x, v.y, 0, v.screenSize, v.screenSize, splatImg:getWidth()/2, splatImg:getHeight()/2)
			end
		end
		--love.graphics.draw(bloodImg, v.x, v.y - v.z, v.a, 1, 1, bloodImg:getWidth()/2, bloodImg:getHeight()/2)
		--love.graphics.circle("fill", v.x, v.y - v.z, 4)
	end


end

function blood_drawSplats()
	--cam_set()
	for i = #splats,1, -1 do
		local v = splats[i]
		love.graphics.draw(splatImg, v.x, v.y, 0, v.screenSize, v.screenSize, splatImg:getWidth()/2, splatImg:getHeight()/2)
		--if(v.screenSize >= v.size) then -- and on_screen(v.x,v.y, 10, 10)) then
			for j=1, num_floors() do
				local x,y,w,h = get_floor(j)

				if(CheckCollision(x,y,w,h,v.x-1,v.y-1,2,2)) then
					--love.graphics.setCanvas(get_floorCanvas(j))
					
					if(v.screenSize >= v.size) then
						cam_unset()
						love.graphics.setCanvas(get_floorCanvas(j))
						love.graphics.draw(splatImg, v.x - x, v.y - y, 0, v.screenSize, v.screenSize, splatImg:getWidth()/2, splatImg:getHeight()/2)
						table.remove(splats,i)
						set_canvas_back()
						cam_set()
					end
				end
			end
		--end
	end
	set_canvas_back()
	--cam_unset()
end