local cam = {x=0, y=0, tx = 0, ty = 0}
local camSpeed = 2
local zoom = 1 -- 0.4 --0.4 -- 0.5

function cam_set()
	love.graphics.push()

	love.graphics.translate(love.graphics.getWidth()/2, love.graphics.getHeight()/2)
	local scale = math.min(love.graphics.getWidth()/640, love.graphics.getHeight()/480) -- 800

	if(state == "play") then
		love.graphics.scale(scale * zoom)
	else
		love.graphics.scale(1)
	end

	love.graphics.push()
	love.graphics.translate(-cam.x, -cam.y)
end

function cam_unset()
	love.graphics.pop()
	love.graphics.pop()
end

function cam_setScale()
	love.graphics.push()

	love.graphics.translate(love.graphics.getWidth()/2, love.graphics.getHeight()/2)
	local scale = math.min(love.graphics.getWidth()/640, love.graphics.getHeight()/480) -- 800

	love.graphics.scale(scale)
end

function cam_unsetScale()
	love.graphics.pop()
end

function get_mousePos()
	return love.mouse.getX() + cam.x - love.graphics.getWidth()/2, love.mouse.getY() + cam.y - love.graphics.getHeight()/2
end

local followMouseAmount = 0.2

function cam_update(dt)
	local camSpeed = camSpeed
	if(player_isAlive() == false) then
		zoom = math.min(2,zoom + (2 - zoom) * dt)
		camSpeed = camSpeed * 5
	else
		if(isAtFountain()) then
			zoom = math.max(1,zoom + (1 - zoom) * 5 * dt)
		else
			--zoom = 1.25
			local tZoom = 1.25 + 0.15 * (1 - player_getLantern()) --1.25
			zoom = math.min(tZoom,zoom + (tZoom - zoom) * 5 * dt)
		end
	end
	
	local px, py = get_charPos(1)
	local mx, my = get_mousePos()

	cam.tx, cam.ty = px, py

	if(player_isAlive() == true) then
		cam.tx = cam.tx - (px - mx) * followMouseAmount
		cam.ty = cam.ty - (py - my) * followMouseAmount
	end

	cam.x = cam.x + (cam.tx - cam.x) * camSpeed * dt
	cam.y = cam.y + (cam.ty - cam.y) * camSpeed * dt

	screen_bounds()
end

function set_camPos(x,y)
	cam.x = x
	cam.y = y
end

function move_cam(x,y)
	cam.x = cam.x + x
	cam.y = cam.y + y
end

function get_cam()
	return cam.x, cam.y
end

local bounds = {}
bounds.x = 0
bounds.y = 0
bounds.w = 0
bounds.h = 0

function on_screen(x,y,w,h)
	if(CheckCollision(x,y,w,h, bounds.x, bounds.y,bounds.w,bounds.h)) then
		return true
	end
	return false
end



function screen_bounds()
	if(state == "play") then
		local scale = math.min(love.graphics.getWidth()/640, love.graphics.getHeight()/480) -- 800
		local x,y,w,h = cam.x - love.graphics.getWidth()/2/scale,cam.y - love.graphics.getHeight()/2/scale, love.graphics.getWidth(), love.graphics.getHeight()
		x,y,w,h = x, y , w / scale, h / scale
		bounds.x = x
		bounds.y = y
		bounds.w = w
		bounds.h = h
	elseif(state == "edit") then
		local scale = math.min(love.graphics.getWidth(), love.graphics.getHeight()) -- 800
		local x,y,w,h = cam.x - love.graphics.getWidth()/2 ,cam.y - love.graphics.getHeight()/2, love.graphics.getWidth(), love.graphics.getHeight()
		bounds.x = x
		bounds.y = y
		bounds.w = w
		bounds.h = h	
	end
	--[[
	love.graphics.setColor(0,0,1)
	love.graphics.rectangle("line",x,y,w,h)
	love.graphics.setColor(0,0,0.5,0.5)
	love.graphics.rectangle("fill",x,y,w,h)
	love.graphics.setColor(1,1,1)
	]]--
end