




--[[
local height = 40
local width = 20
]]

local chars = {}

function chars_reset()
	chars = {}
end

function new_char()
	local inactive = 0
	for i,v in ipairs(chars) do
		if(v.active == false) then
			inactive = i
			break
		end
	end

	local char = {}
	if(inactive ~= 0) then
		char = chars[inactive]
	end
	
	char.handTrail = {}
	
	char.timeOffScreen = 0

	char.width = 20
	char.height = 40
	char.x = math.random(100,300)
	char.y = math.random(100,300)
	char.z = 0
	char.angle = 0
	char.moveAngle = 0

 	char.armHeight = 31
	char.armDepth = 0.1
	char.bodyHeight = 20
	char.headHeight = 35
	char.legHeight = 20

	char.armLength = 20

	char.armAngle = 0

	char.lastStepped = {}
	char.lastStepped.x = 0
	char.lastStepped.y = 0
	char.foot = {}
	char.foot.x1 = 0
	char.foot.y1 = 0
	char.foot.x2 = 0
	char.foot.y2 = 0

	char.foot.sx1 = 0
	char.foot.sy1 = 0
	char.foot.sx2 = 0
	char.foot.sy2 = 0

	char.anim = 0

	char.xvel = 0
	char.yvel = 0
	char.zvel = 0

	char.dx = 0 -- force from controller, move direction
	char.dy = 0 

	char.maxHp = 3
	char.hp = 3

	char.weapon = 0
	char.holdingAttack = false
	char.attacking = false
	char.attackPower = 0
	char.lastAttackPower = 0
	char.wepAngle = 0
	char.lastDmgAngle = 0
	char.attackTimer = 0
	char.attackSpeed = 5
	char.armLength = 25
	char.active = true
	char.knocked = false
	char.team = 1
	char.bob = 0
	
	char.prevHandX = 0
	char.prevHandY = 0
	char.handTrailTimer = 0
	
	char.standup = 0
	if(inactive == 0) then
		table.insert(chars,char)
		return #chars
	end

	

	return inactive
end

function get_charMaxHp(i)
	return chars[i].maxHp
end

function add_charHp(i,amount)
	if(chars[i]) then
		chars[i].hp = math.min(chars[i].maxHp, chars[i].hp + amount)
	end
end

function set_charMaxHp(i,max)
	chars[i].maxHp = max
	chars[i].hp = max
end

function get_charHp(i)
	return chars[i].hp
end

function get_char(i)
	return chars[i]
end

function get_charPos(i)
	if(#chars >= i) then
		return chars[i].x, chars[i].y
	else
		return 0, 0
	end
end

function set_charWeapon(i,wep)
	chars[i].weapon = wep
end

function set_charPos(i,x,y)
	local char = chars[i]
	char.x = x
	char.y = y
	char.foot.x1 = x
	char.foot.y1 = y
	char.foot.x2 = x
	char.foot.y2 = y

	char.foot.sx1 = x
	char.foot.sy1 = y
	char.foot.sx2 = x
	char.foot.sy2 = y
	
	char.angle = math.pi/2
	
	char.standup = 2
	
	char.foot.x1 = char.x + math.cos(char.angle + math.pi/2) * char.width/2 
	char.foot.y1 = char.y + math.sin(char.angle + math.pi/2) * char.width/2 

	char.foot.x2 = char.x - math.cos(char.angle + math.pi/2) * char.width/2 
	char.foot.y2 = char.y - math.sin(char.angle + math.pi/2) * char.width/2
	
	char.lastStepped.x = x
	char.lastStepped.y = y
end

function anim_char(char, anim)
	chars[char].anim = anim
end

function dmg_char(i, x, y, power)
	local char = chars[i]
	if(char.knocked == false and char.active == true) then
		
		add_hitstop(0.0, 0.1)
		
		local angle = math.atan2(y - char.y, x - char.x)
		char.angle = angle
		local f = math.max(50,math.random(power - 50,power + 50))
		char.xvel = -math.cos(angle) * f
		char.yvel = -math.sin(angle) * f
		char.knocked = true
		local dmg = 1
		if(power/250 > 0.2) then
			dmg = math.max(0.34,power/250) * 3
			if(dmg == 3 and char.team == 2) then
				play_sfx("smash",char.x, char.y)
			
				char.active = false

				add_physObj("head2", char.x, char.y, char.headHeight + 5, char.angle, char.xvel * 1.25, char.yvel* 1.25, 250)
				add_physObj("body", char.x, char.y, char.bodyHeight, char.angle, char.xvel, char.yvel, 100)	
				add_physObj("leftZombArm", char.x - math.cos(char.angle+math.pi/2)*10 + math.cos(char.angle) * 15, char.y - math.sin(char.angle+math.pi/2)*10 + math.sin(char.angle) * 15, char.bodyHeight*1, char.angle, char.xvel - math.cos(char.angle+math.pi/2) * 100, char.yvel - math.sin(char.angle+math.pi/2) * 100, 75)	
				add_physObj("rightZombArm", char.x + math.cos(char.angle+math.pi/2)*10, char.y + math.sin(char.angle+math.pi/2)*10, char.armHeight*1, char.angle, char.xvel + math.cos(char.angle+math.pi/2) * 100, char.yvel + math.sin(char.angle+math.pi/2) * 100, 75)	

			end
			if(char.team == 1) then dmg = 1 end
			char.hp = char.hp - dmg
			local r= math.random(1,4)
			if(r==1 or dmg == 3) then
				add_hitstop(0.05, 0.25)
			end
			--add_spark(char.x, char.y - 50 , {0.9,0.9,0.9}, dmg * 15, angle, 60, "smoke")
			
		end
		--add_spark(char.x, char.y - 50 , {1,0,0}, dmg * 7, angle, 60, "smoke")
		if(dmg == 1) then
			if(char.team == 1) then
				add_spark(char.x, char.y - 50 , {0.2,0.8,0.2}, 5, angle, 60, "blood")
				add_spark(char.x, char.y - 50 , {0.2,0.4,0.2}, 5, angle, 60, "blood")
			else
				add_spark(char.x, char.y - 50 , {0.2,0.2,0.2}, 3, angle, 30, "blood")
				add_spark(char.x, char.y - 50 , {0.4,0.2,0.4}, 3, angle, 40, "blood")

			end
		elseif(dmg == 3) then
			add_spark(char.x, char.y - 35 , {0.5,0,0}, dmg * 7, angle, 60, "blood", char.xvel*0.3, char.yvel*0.3)
			--add_spark(char.x, char.y - 50 , {0.2,0,0}, 10, angle, 45, "dust", char.xvel*0.3, char.yvel*0.3)
			
			--add_spark(char.x, char.y - 25 , {0.6,0.0,0.0}, dmg * 7, angle, 30, "blood")
		end
		if(dmg > 1) then
			add_blood(char.x, char.y, dmg * 4,angle + math.pi)
			add_spark(char.x, char.y - 50 , {0.4,0,0}, 10, angle, 45, "dust", char.xvel*0.3, char.yvel*0.3)
		end
		if(dmg == 1) then
			char.zvel = 90
		else
			char.zvel = math.random(90,120)
		end
		char.z = char.height/2

		play_sfx("grunt",char.x, char.y)
		play_sfx("smash2",char.x, char.y)
	end
end

function attack_char(i)
	local char = chars[i]

	if(char.attackTimer == 0) then
		char.attacking = true
		char.holdingAttack = true
	end
end

function move_char(i,angle,moveAngle, xvel, yvel)
	if(#chars >= i) then
		local char = chars[i]
		if(char.knocked == false and char.standup < 0.5) then
			char.angle = angle
			char.moveAngle = moveAngle
			char.dx = xvel
			char.dy = yvel
		end
	end
end

function num_chars()
	return #chars
end

local gravity = 350
local airRes = 60

local handTrailTime = 0.016/2
local handTrailLife = 0.15
function char_update(dt)

	for i,char in ipairs(chars) do
		if not(i == 1) then


		end
		


		if(love.keyboard.isDown("k") and i ~= 1) then
			char.hp = 0
		end

		if(char.active) then

			if(on_ground(char.x, char.y) == false and i > 1) then
				char.active = false
				break
			end

			if(char.knocked) then
				char.standup = 1
			else
				char.standup = math.max(0, char.standup - dt * 2)
			end
			
			local bobSpeed = 6
			local bobAmount = 1
			if(char.dx ~= 0 or char.dy ~= 0) then
				bobAmount = 2
				bobSpeed = 20
			end
			if(char.standup == 0) then
				char.bob = char.bob + dt * bobSpeed
				char.bob = char.bob % (2*math.pi)
			end
			local bob = math.cos(char.bob) * bobAmount + char.standup * -20
			char.armHeight = 31 + bob
			char.bodyHeight = 20 + bob
			char.headHeight = 35 + bob
			char.legHeight = 20 + bob


			char.handTrailTimer = math.max(0, char.handTrailTimer - dt)

			if(char.handTrailTimer <= 0 and char.attacking and char.attackPower == 0 and char.lastAttackPower > 0.2) then
			--if(char.attacking or 1 == 1) then
				char.handTrailTimer = char.handTrailTimer + handTrailTime
				local twist = 0
				if(char.weapon ~= 0 and char.lastAttackPower > 0.2) then twist = - char.attackTimer * 1 end
				twist = twist + char.attackPower * 1
				if(char.lastAttackPower <= 0.2 and char.attackPower == 0) then
					twist = char.attackTimer * 1
				end
				if(char.weapon == 0) then twist = 0 end	
				
				
				local handX = char.x + math.cos(char.angle + char.armAngle + char.attackPower * 0.1 + twist) * char.armLength
				local handY = char.y + math.sin(char.angle + char.armAngle + char.attackPower * 0.1 + twist) * char.armLength	

				char.handTrail[#char.handTrail + 1] = {x=handX, y=handY, timer = 0, angle = char.wepAngle + twist}
			end

			for j=#char.handTrail,1,-1 do
				local t = char.handTrail[j]
				t.timer = t.timer + dt
				if(t.timer > handTrailLife) then
					table.remove(char.handTrail, j)
				end
			end
			
			if(on_screen(char.x-50,char.y-50,100,100) == false) then
				if(isAtFountain() == true) then
					char.active = false
				end

				char.timeOffScreen = char.timeOffScreen + dt
				if(char.timeOffScreen > 12 ) then
					char.active = false
				end
			end


			if(char.knocked) then
				char.attackPower = 0
				char.attacking = false
				char.holdingAttack = false
			end
			-- attacking
			if(char.holdingAttack and char.attackTimer == 0) then
				char.attackPower = math.min(1,char.attackPower + dt)
			end
			if(char.holdingAttack == false and char.attackPower > 0) then
				if(char.team == 1) then
					play_sfx("swing",0,0)
				end
				--[[
				if(char.team == 1) then
					anim_char(i,1)
				elseif(char.team == 2) then
					anim_char(i,3)
				end
				]]--
				if(char.weapon == 0 and char.attackPower < 1) then

				elseif(char.attackPower < 0.2) then
					add_hitbox(char.team, char.x, char.y, char.angle, 100, math.pi, char.attackPower * 250)
				end
				char.lastDmgAngle = char.angle + char.armAngle - math.pi
				--char.attacking = false
				char.lastAttackPower = char.attackPower
				char.attackPower = 0
			end

			if(char.lastAttackPower > 0.2 and char.attackTimer > 0 and char.attacking) then
				local angle = char.angle + char.armAngle - char.attackTimer
				dif = angle - char.lastDmgAngle
				dif = math.abs((dif + math.pi) % (2*math.pi) - math.pi)	

				if(char.weapon == 1) then
					add_hitbox(char.team, char.x, char.y, char.angle + char.armAngle - char.attackTimer, 100, dif, char.lastAttackPower * 250)
				else
					add_hitbox(char.team, char.x, char.y, char.angle, 40, math.pi/2, char.lastAttackPower * 250)
				end
				char.lastDmgAngle = char.angle + char.armAngle -char.attackTimer
			
			end

			char.holdingAttack = false

			local footSpeed = 25
			if(char.knocked) then footSpeed = 15 end
			-- lerp foot pos
			char.foot.sx1 = char.foot.sx1 + (char.foot.x1 - char.foot.sx1) * footSpeed * dt
			char.foot.sy1 = char.foot.sy1 + (char.foot.y1 - char.foot.sy1) * footSpeed * dt
			char.foot.sx2 = char.foot.sx2 + (char.foot.x2 - char.foot.sx2) * footSpeed * dt
			char.foot.sy2 = char.foot.sy2 + (char.foot.y2 - char.foot.sy2) * footSpeed * dt
			-- physics
			if(char.knocked) then
				local dx, dy = math.cos(char.angle+math.pi/2) * char.width*1/4, math.sin(char.angle+math.pi/2) * char.width*1/4
				local dx2, dy2 = math.cos(char.angle) * 10, math.sin(char.angle) * 10

				local x1, y1 = dx2 + dx + char.x, dy2 + dy + char.y - char.z
				local x2, y2 = dx2 + -dx + char.x,dy2 + -dy + char.y - char.z


				char.foot.x1 = x1 + math.cos(char.angle + 0.2) * 20
				char.foot.y1 = y1 + math.sin(char.angle+ 0.2) * 20

				char.foot.x2 = x2 + math.cos(char.angle- 0.2) * 20
				char.foot.y2 = y2 + math.sin(char.angle- 0.2) * 20
				char.zvel = char.zvel - gravity * dt

				if(char.z + char.zvel * dt < 0) then
					if(char.hp <= 0 and char.team == 2) then
						char.active = false
						add_physObj("head2", char.x - math.cos(char.angle) * char.headHeight/2, char.y - math.sin(char.angle) * char.headHeight/2, char.z, char.angle, char.xvel * 1.4, char.yvel* 1.4, char.zvel)
						add_physObj("body", char.x, char.y, char.z, char.angle, char.xvel, char.yvel, char.zvel)

						add_physObj("arm2", char.x - math.cos(char.angle+math.pi/2)*10, char.y - math.sin(char.angle+math.pi/2)*10, char.z, char.angle, char.xvel - math.cos(char.angle+math.pi/2) * 100, char.yvel - math.sin(char.angle+math.pi/2) * 100, 75)	
						add_physObj("arm2", char.x + math.cos(char.angle+math.pi/2)*10, char.y + math.sin(char.angle+math.pi/2)*10, char.z, char.angle, char.xvel + math.cos(char.angle+math.pi/2) * 100, char.yvel + math.sin(char.angle+math.pi/2) * 100, 75)	


					end

					char.z = 0
					char.zvel = -char.zvel * 0.75
					char.xvel = char.xvel * 0.75
					char.yvel = char.yvel * 0.75
					if(math.abs(char.zvel) < 100) then
						if(i == 1 and char.hp <= 0) then

						else
							if(i == 1) then
								add_hitbox(char.team, char.x, char.y, 0, 50, math.pi*2, 0.25 * 250)
							end
							char.knocked = false
						end
						char.z = 0
						char.zvel = 0
						
						--char.foot.x1 = char.x
						--char.foot.y1 = char.y
						--char.foot.x2 = char.x
						--char.foot.y2 = char.y
						
						char.foot.x1 = char.x + math.cos(char.angle + math.pi/2) * char.width/2 
						char.foot.y1 = char.y + math.sin(char.angle + math.pi/2) * char.width/2 

						char.foot.x2 = char.x - math.cos(char.angle + math.pi/2) * char.width/2 
						char.foot.y2 = char.y - math.sin(char.angle + math.pi/2) * char.width/2 					
						
						char.lastStepped.x, char.lastStepped.y = char.x, char.y
					end
				end

				char.moveAngle = math.atan2(char.yvel, char.xvel)
				char.xvel = char.xvel - math.cos(char.moveAngle) * airRes * dt
				char.yvel = char.yvel - math.sin(char.moveAngle) * airRes * dt

				if(math.sqrt(char.xvel^2 + char.yvel^2) <= 10) then
					--char.knocked = false
					--char.z = 0
					--char.zvel = 0
				end
			else
				if(char.standup > 0.5) then
					char.xvel = 0
					char.yvel = 0
				else
					char.xvel = char.dx * (1-char.standup)
					char.yvel = char.dy * (1-char.standup)
				end
			end

			-- repel
			
			for j,k in ipairs(chars) do
				if (j ~= i and k.active == true) then
					local d = dist(char.x, char.y, k.x, k.y)
					if(d < 40) then
						if(char.knocked == false and k.knocked == true and k.team == char.team) then
							if(math.sqrt(k.xvel^2 + k.yvel^2) > 100) then
								char.attackTimer = 0
								add_blood(char.x, char.y, 10,k.angle + math.pi)
								char.hp = char.hp - 1
								char.knocked = true
								char.xvel = k.xvel * 0.75
								char.yvel = k.yvel * 0.75
								char.z = char.height / 2
								char.zvel = math.random(80,100)
								k.zvel = k.zvel * 0.5
								k.xvel = k.xvel * 0.25
								k.yvel = k.yvel * 0.25
								
								play_sfx("pushup", k.x, k.y)
								play_sfx("smash2", k.x, k.y)
							end
						end
						--if(char.knocked == false) then
							local a = math.atan2(char.y - k.y, char.x - k.x)
							local force = 1/(d+0.00001) * 200
							if(k.knocked) then force = force * 10 end
							if(char.knocked) then
								char.xvel = char.xvel + math.cos(a) * force * dt
								char.yvel = char.yvel + math.sin(a) * force * dt
							else
								char.xvel = char.xvel + math.cos(a) * force
								char.yvel = char.yvel + math.sin(a) * force
							end
						--end
					end
				end
			end

			char.x, char.y, char.xvel, char.yvel = world_col(char.x, char.y, 20, 20, char.xvel, char.yvel, dt)

			char.x = char.x + char.xvel * dt
			char.y = char.y + char.yvel * dt

			char.z = char.z + char.zvel * dt

			-- animate
			local attackSpeed = char.attackSpeed
			if(char.weapon == 0) then attackSpeed = attackSpeed * 2 end
			if(char.lastAttackPower <= 0.2) then attackSpeed = attackSpeed * 2 end
			if(char.attacking and char.attackPower == 0) then
				if(char.lastAttackPower > 0.2) then
					char.attackTimer = math.min(1, char.attackTimer + attackSpeed * math.max(0.5, char.lastAttackPower) * dt)
				else
					char.attackTimer = math.min(1, char.attackTimer + attackSpeed * dt)
				end
				--char.armAngle = math.pi/2 - math.pi * char.attackTimer

				if(char.attackTimer == 1) then
					char.attacking = false
				end
			elseif(char.attacking == false and char.attackTimer > 0) then
				char.attackTimer = math.max(0, char.attackTimer - attackSpeed/2 * dt)
			end

			if(char.lastAttackPower <= 0.2 and char.attackTimer > 0) then
				char.armLength = 25 + char.attackTimer * 20
				char.armAngle = 1.15 - 1.15 * char.attackTimer - char.attackTimer * 0.5 --1.15 * char.attackTimer 
				char.wepAngle = char.angle + math.pi/2 * char.attackTimer + 2 - 1.75 * char.attackTimer -- + char.attackTimer
			else
				char.armAngle = 1.15 - 2.3 * char.attackTimer
				char.armLength = 25 -- + char.attackTimer * 40
				char.wepAngle = char.angle + 2 - 3 * char.attackTimer + char.attackPower * 0.75 --char.angle + char.armAngle * 1.3 + 0.75 + char.attackPower * 0.75--0.75
			end

			--[[
			if(char.anim == 0) then
				char.armAngle = math.min(char.armAngle + 12 * dt, math.pi*1.5/4)
			elseif(char.anim == 1) then
				char.armAngle = char.armAngle - 10 * dt
				if(char.armAngle < -math.pi/2) then
					char.anim = 0
					--char.armAngle = math.pi*1.5/4
				end
			elseif(char.anim == 2) then
				--char.armAngle = 0
				char.armAngle = math.max(0, char.armAngle - dt)
			elseif(char.anim == 3) then
				char.armAngle = char.armAngle - 12 * dt
				if(char.armAngle < -math.pi/2) then
					char.anim = 2
					--char.armAngle = math.pi*1.5/4
				end
			end
			]]


			if(char.hp <= 0 and char.knocked == false) then -- and char.knocked == false) then
				if(i == 1) then -- if it is player
					--load_lvl()
				else
					--char.active = false
					--add_physObj("head2", char.x - math.cos(char.angle) * char.headHeight/2, char.y - math.sin(char.angle) * char.headHeight/2, char.z, char.angle, char.xvel * 1.1, char.yvel* 1.1, char.zvel* 1.1)
					--add_physObj("knockedBody", char.x, char.y, char.z, char.angle, char.xvel, char.yvel, char.zvel)
				end
			end
		end

		char.dx = 0
		char.dy = 0
	end
end

local bodyImg = love.graphics.newImage("body.png")
local headImg = love.graphics.newImage("head.png")
local armImg = love.graphics.newImage("arm.png")
local knockedImg = love.graphics.newImage("knocked/body.png")
local knockedArmImg = love.graphics.newImage("knocked/arm.png")
local knockedArmImg2 = love.graphics.newImage("knocked/arm2.png")
local shadowImg = love.graphics.newImage("shadow.png")

local stickImg = love.graphics.newImage("stick.png")

function char_draw()
	for i,char in ipairs(chars) do
		if(i == 1) then
			sfx_setListenerPosition(char.x,char.y)
		end
		
		if(on_screen(char.x - 50, char.y - 50, 100,100)) then
			char.timeOffScreen = 0
			local curChar = i
			if(char.active) then
				if not(char.knocked) then
					love.graphics.setColor(0,0,0,0.3)
					love.graphics.draw(shadowImg, (char.foot.sx1 + char.foot.sx2)/2, (char.foot.sy1 + char.foot.sy2)/2, 0, 1, 1.5, shadowImg:getWidth()/2, shadowImg:getHeight()/2)
					love.graphics.setColor(1,1,1)
				end
				
				local forceStep = false
				if(dist(char.x,char.y,char.foot.x1,char.foot.y1) > 30) then
					forceStep = true
					char.stepSide = 1
				elseif(dist(char.x,char.y,char.foot.x2,char.foot.y2) > 30) then
					forceStep = true
					char.stepSide = 2
				end
				
				if(char.knocked == false and char.standup <= 0.5 and (dist(char.lastStepped.x, char.lastStepped.y, char.x,char.y) > 20 or forceStep == true))then

					if not(i == 1) then
						if(char.stepSide == 1) then
							play_sfx("footstep", char.x, char.y)
						end
					else
						play_sfx("player_footstep", char.x, char.y)
					end	
					
					char.lastStepped.x = char.x
					char.lastStepped.y = char.y

					if(char.stepSide == 1) then
						char.stepSide = 0
						char.foot.x1 = char.x + math.cos(char.angle + math.pi/2) * char.width/2 + math.cos(char.moveAngle) * 20
						char.foot.y1 = char.y + math.sin(char.angle + math.pi/2) * char.width/2 + math.sin(char.moveAngle) * 20
					else
						char.stepSide = 1
						char.foot.x2 = char.x - math.cos(char.angle + math.pi/2) * char.width/2 + math.cos(char.moveAngle) * 20
						char.foot.y2 = char.y - math.sin(char.angle + math.pi/2) * char.width/2 + math.sin(char.moveAngle) * 20
					end
				end

				local twist = 0

				if(char.knocked) then
					love.graphics.setColor(0,0,0,0.3)
					love.graphics.draw(shadowImg, char.x, char.y, 0, 1, 1.5, shadowImg:getWidth()/2, shadowImg:getHeight()/2)
					love.graphics.setColor(1,1,1)


					local dx, dy = math.cos(char.angle + math.pi/2 + twist) * char.width*0.6, math.sin(char.angle + math.pi/2 + twist) * char.width * 0.6
					local lArmX = char.x + dx
					local lArmY = dy + char.y

					local rArmX = char.x - dx
					local rArmY = -dy + char.y

					local ox, oy = -math.cos(char.angle), -math.sin(char.angle)

					if(char.team == 1) then
						model_draw("armour", char.x, char.y - char.z, char.angle, 1, 1, 0, 0.5, char.z,true)
						model_draw("shoulder", lArmX + ox * 15, lArmY - char.z + oy * 15, char.angle + twist, 1, 1, 0.5, 0.5, char.z, true)
						model_draw("shoulder", rArmX + ox * 15, rArmY - char.z + oy * 15, char.angle + twist, 1, 1, 0.5, 0.5, char.z, true)
					else
						model_draw("body", char.x, char.y - char.z, char.angle, 1, 1, 0, 0.5, char.z,true)
					end

					--model_draw("body", char.x, char.y - char.z - char.bodyHeight, char.angle, 1, 1, 0.5, 0.5, char.z, true)
					
					
					if(char.team == 1) then
						model_draw("helmet", char.x + ox * 19, char.y + oy * 19 - char.z, char.angle, 1, 1, 0.5, 0.5, char.z, true)
					else
						model_draw("head2", char.x + ox * 19, char.y + oy * 19 - char.z, char.angle, 1, 1, 0.5, 0.5, char.z + 1, true)
					end

					ox, oy = math.cos(char.angle + math.pi/2) * char.width*0.6, math.sin(char.angle + math.pi/2) * char.width * 0.6
					local ox2, oy2 = -math.cos(char.angle) * 11, -math.sin(char.angle) * 11
					if(char.team == 2) then

						model_draw("leftZombArm", char.x+ox+ox2, char.y+oy+oy2 - char.z - 12, char.angle, 1, 1, 0.5, 0.5, char.z + 12, true)
						model_draw("rightZombArm", char.x-ox+ox2, char.y-oy+oy2 - char.z - 12, char.angle, 1, 1, 0.5, 0.5, char.z + 12, true)
					else
						model_draw("leftPlayerArm", char.x+ox+ox2, char.y+oy+oy2 - char.z - 12, char.angle, 1, 1, 0.5, 0.5, char.z + 12, true)
						model_draw("rightPlayerArm", char.x-ox+ox2, char.y-oy+oy2 - char.z - 12, char.angle, 1, 1, 0.5, 0.5, char.z + 12, true)
					end

					-- legs

					--[[
					love.graphics.setLineWidth(8)
					love.graphics.setColor(65/255,32/255,0)
					--love.graphics.circle("fill", char.foot.sx1,char.foot.sy1 - 3, 8)
					--love.graphics.circle("fill", char.foot.sx2,char.foot.sy2 - 3, 8)

					love.graphics.setColor(55/255,55/255,55/255)
					love.graphics.circle("fill", char.foot.sx1,char.foot.sy1 - 3, 4)
					love.graphics.circle("fill", char.foot.sx2,char.foot.sy2 - 3, 4)

					local dx, dy = math.cos(char.angle+math.pi/2) * char.width*1/4, math.sin(char.angle+math.pi/2) * char.width*1/4
					local dx2, dy2 = math.cos(char.angle) * 10, math.sin(char.angle) * 10
					love.graphics.line(dx2 + dx + char.x,dy2 + dy + char.y - char.z - 3,char.foot.sx1, char.foot.sy1 - 3)
					love.graphics.line(dx2 + -dx + char.x,dy2 + -dy + char.y - char.z - 3,char.foot.sx2, char.foot.sy2 - 3)

					love.graphics.setColor(1,1,1)
					love.graphics.setLineWidth(1)

					]]

				else
					
					if(char.weapon ~= 0 and char.lastAttackPower > 0.2) then twist = - char.attackTimer * 1 end
					twist = twist + char.attackPower * 1
					if(char.lastAttackPower <= 0.2 and char.attackPower == 0) then
						twist = char.attackTimer * 1
					end
					if(char.weapon == 0) then twist = 0 end
					

					


					-- arms

					local dx, dy = math.cos(char.angle + math.pi/2 + twist) * char.width*0.6, math.sin(char.angle + math.pi/2 + twist) * char.width * 0.6
					local lArmX = char.x + dx
					local lArmY = dy + char.y

					local rArmX = char.x - dx
					local rArmY = -dy + char.y

					if(char.weapon == 0) then
						lArmX = lArmX + math.cos(char.angle + twist) * -3
						lArmY = lArmY + math.sin(char.angle + twist) * -3

						rArmX = rArmX + math.cos(char.angle + twist) * -3
						rArmY = rArmY + math.sin(char.angle + twist) * -3
					end

					if(char.weapon == 1) then -- holding
						love.graphics.setColor(68/255,68/255,68/255)
						love.graphics.setLineWidth(6)
						local handX = char.x + math.cos(char.angle + char.armAngle + char.attackPower * 0.1 + twist) * char.armLength
						local handY = char.y + math.sin(char.angle + char.armAngle + char.attackPower * 0.1 + twist) * char.armLength
						
						local handOffset = 15
						local ox, oy = math.cos(char.wepAngle + twist) * handOffset, math.sin(char.wepAngle + twist) * handOffset

						--love.graphics.line(lArmX, lArmY - char.height * char.armHeight, handX, handY - char.height * char.armHeight)
						--love.graphics.line(rArmX, rArmY - char.height * char.armHeight, handX - ox, handY - char.height * char.armHeight - oy)
						--add_drawable("line", {x1 = lArmX , y1 = lArmY - char.armHeight, x2 = handX + ox/2, y2 = handY - char.armHeight + oy/2, width = 6, height = char.armHeight})
						--add_drawable("line", {x1 = rArmX, y1 = rArmY - char.armHeight, x2 = handX - ox/2, y2 = handY - char.armHeight - oy/2, width = 6, height = char.armHeight})

						--[[
						for i = 3,1,-1 do -- draw arm
							love.graphics.setColor(68/255 - i/3 * 0.25,68/255 - i/3 * 0.25,68/255 - i/3 * 0.25)
							love.graphics.setLineWidth(6 * i/3)
							love.graphics.line(lArmX , lArmY - char.armHeight, handX + ox/2, handY - char.armHeight + oy/2)
							love.graphics.line(rArmX , rArmY - char.armHeight, handX - ox/2, handY - char.armHeight - oy/2)
							love.graphics.setColor(1,1,1)
						end
						]]
						
						--model_draw("line",handX + ox/2, handY - char.armHeight + oy/2,0 , 1, 1,lArmX , lArmY - char.armHeight , char.armHeight - 1, false, false)
						model_draw("line", lArmX - (lArmX - (handX + ox/2)) * 0.15 , lArmY - (lArmY - (handY + oy/2))*0.15 - char.armHeight,0 , 1, 1, handX + ox/2, handY - char.armHeight + oy/2, char.bodyHeight + 1, false, false)
						model_draw("line", rArmX - (rArmX - (handX - ox/2)) * 0.15, rArmY - (rArmY - (handY - oy/2))*0.15 - char.armHeight,0 , 1, 1, handX - ox/2, handY - char.armHeight - oy/2, char.bodyHeight + 1, false, false)


						--if(char.lastAttackPower <= 0.2 and char.attackTimer > 0) then
							--model_draw("weapon", handX, handY - char.armHeight, char.wepAngle + twist, 1, 1, 0.5, 0.5, char.armHeight)
						--else
						if(char.team == 1) then
							--[[
							for j=char.attackTimer * 10,0,-1 do
								model_draw("weapon2", handX, handY - char.armHeight, char.wepAngle + twist + j, 1, 1, 0.3, 0.5, char.armHeight)
							
							end
							--]]
							for j=#char.handTrail,1,-1 do
								local t = char.handTrail[j]
								model_draw("weapon2", t.x, t.y - char.armHeight, t.angle, 1, 1, 0.3, 0.5, char.armHeight - 1, false, (1 - t.timer/handTrailLife) * 0.33)
							
							end
							
							model_draw("weapon2", handX, handY - char.armHeight, char.wepAngle + twist, 1, 1, 0.3, 0.5, char.armHeight)
							--model_draw("weapon", char.x - math.cos(char.angle)*6, char.y - 40  - math.sin(char.angle)*6, char.angle + twist, 1, 1, 0.5, 0.5, 40, true)
						else
							model_draw("weapon2", handX, handY - char.armHeight, char.wepAngle + twist, 1, 1, 0.3, 0.5, char.armHeight)
						end
						--end
						--add_drawable("img", {img = stickImg, x = handX, y = handY - char.height * char.armHeight - 1, angle = wepAngle, sx = 1, sy = 1, ox = stickImg:getWidth()*0.3, oy = stickImg:getHeight()/2, height = char.height * char.armHeight + 1 })
						--add_drawable("img", {img = stickImg, x = handX, y = handY - char.height * char.armHeight , angle = wepAngle, sx = 1, sy = 1, ox = stickImg:getWidth()*0.3, oy = stickImg:getHeight()/2, height = char.height * char.armHeight })
						--add_drawable("img", {img = stickImg, x = handX, y = handY - char.height * char.armHeight  + 1, angle = wepAngle, sx = 1, sy = 1, ox = stickImg:getWidth()*0.3, oy = stickImg:getHeight()/2, height = char.height * char.armHeight - 1 })
					
						love.graphics.setColor(0,0,0)
						love.graphics.circle("fill", handX+ox/2, oy/2 + handY - char.armHeight, 3)
						love.graphics.circle("fill", handX -ox/2, handY -oy/2 - char.armHeight, 3)

						love.graphics.setLineWidth(1)
						love.graphics.setColor(1,1,1)
					end

					--love.graphics.circle("fill", x + dx, dy + y - height * armHeight, 2)
					--love.graphics.circle("fill", -dx + x, -dy + y - height * armHeight, 2)

					--love.graphics.rectangle("fill", x, y, w, h)
					
					--model_draw("head", char.x - math.cos(char.angle) * 6, char.y - char.height/2 - math.sin(char.angle) * 6, char.angle, 1, 1, 0.5, 0.5, char.height/2)
					if(char.team == 1) then
						model_draw("armour", char.x, char.y - char.bodyHeight, char.angle + twist, 1, 1, 0.5, 0.5, char.bodyHeight)
					else
						model_draw("body", char.x, char.y - char.bodyHeight, char.angle + twist, 1, 1, 0.5, 0.5, char.bodyHeight)
					end
					
					if(char.team == 1) then
						if(char.knocked) then

						else
							model_draw("shoulder", lArmX, lArmY - char.armHeight - 1, char.angle + twist, 1, 1, 0.5, 0.5, char.armHeight + 1)
							model_draw("shoulder", rArmX, rArmY - char.armHeight - 1, char.angle + twist, 1, 1, 0.5, 0.5, char.armHeight + 1)
						end
					end

					if(char.team == 1) then
						model_draw("helmet", char.x, char.y - char.headHeight, char.angle + twist/2, 1, 1, 0.5, 0.5, char.headHeight)
					else
						model_draw("head2", char.x, char.y - char.headHeight, char.angle, 1, 1, 0.5, 0.5, char.headHeight)
					end

					--add_drawable("img", {img = armImg, x = lArmX, y = lArmY - i, angle = char.angle + char.attackPower * 0.5, sx = 1, sy = 1, ox = 0, oy = armImg:getHeight()/2, height = i})
					--add_drawable("img", {img = armImg, x = rArmX, y = rArmY - i, angle = char.angle - char.attackPower * 0.5, sx = 1, sy = 1, ox = 0, oy = armImg:getHeight()/2, height = i})

					if(char.weapon == 0) then
						if not(char.attacking and char.attackPower == 0) then
							model_draw("rightZombArm", lArmX, lArmY - char.armHeight, char.angle - char.attackTimer * 0.5 + char.attackPower * 0.5, 1, 1, 0, 0.5, char.armHeight)
							model_draw("leftZombArm", rArmX, rArmY - char.armHeight, char.angle + char.attackTimer * 0.5 - char.attackPower * 0.5, 1, 1, 0, 0.5, char.armHeight)
						else
							model_draw("rightZombArm", lArmX, lArmY - char.armHeight, char.angle - char.attackTimer * 1 + char.lastAttackPower * 0.5, 1, 1, 0, 0.5, char.armHeight)
							model_draw("leftZombArm", rArmX, rArmY - char.armHeight, char.angle + char.attackTimer * 1 - char.lastAttackPower * 0.5, 1, 1, 0, 0.5, char.armHeight)
						end
					end

					--[[
					local dx2, dy2 = math.cos(angle + armAngle) * width * math.cos(angle), math.sin(angle + armAngle) * width

					love.graphics.setColor(1,0,0)

					love.graphics.circle("fill", x + dx - dx2, dy + dy2 + y - height * armHeight, 2)

					love.graphics.setColor(1,1,1)
					]]

					love.graphics.setColor(0,1,0)
					--love.graphics.print(char.hp, char.x, char.y)
					love.graphics.setColor(1,1,1)
				end

-- legs
					love.graphics.setLineWidth(8)
					love.graphics.setColor(65/255,32/255,0)
					--love.graphics.circle("fill", char.foot.sx1,char.foot.sy1, 8)
					--love.graphics.circle("fill", char.foot.sx2,char.foot.sy2, 8)

					
					love.graphics.circle("fill", char.foot.sx1,char.foot.sy1, 4)
					love.graphics.circle("fill", char.foot.sx2,char.foot.sy2, 4)

					love.graphics.setColor(55/255,55/255,55/255)
					local dx, dy = math.cos(char.angle+math.pi/2 + twist) * char.width*1/4, math.sin(char.angle+math.pi/2 + twist) * char.width*1/4
					--if(char.team == 1) then
						
						love.graphics.setColor(0,0,0)
						if(char.team == 2) then love.graphics.setColor(82/255 - 3/3 * 0.25,41/255 - 3/3 * 0.25,0/255 - 3/3 * 0.25) end
						if(char.knocked) then
							love.graphics.circle("fill",dx + char.x,dy + char.y- char.z,4)
							love.graphics.circle("fill",-dx + char.x,-dy + char.y  -char.z,4)
							love.graphics.line(dx + char.x,dy + char.y  -char.z, -dx + char.x,-dy + char.y  -char.z)
						else
							love.graphics.circle("fill",dx + char.x,dy + char.y- char.z - char.legHeight,4)
							love.graphics.circle("fill",-dx + char.x,-dy + char.y  -char.z - char.legHeight,4)
							love.graphics.line(dx + char.x,dy + char.y  -char.z - char.legHeight, -dx + char.x,-dy + char.y  -char.z - char.legHeight)
						end
						
						for i = 3,1,-1 do
							if(char.team == 1) then
								love.graphics.setColor(68/255 - i/3 * 0.25,68/255 - i/3 * 0.25,68/255 - i/3 * 0.25)
							else
								love.graphics.setColor(82/255 - i/3 * 0.25,41/255 - i/3 * 0.25,0/255 - i/3 * 0.25)
							end
							love.graphics.setLineWidth(8 * i/3)
							if(char.knocked) then
								love.graphics.line(dx + char.x,dy + char.y- char.z,char.foot.sx1, char.foot.sy1)
								love.graphics.line(-dx + char.x,-dy + char.y- char.z,char.foot.sx2, char.foot.sy2)
							else
							
								love.graphics.line(dx + char.x,dy + char.y - char.legHeight- char.z,char.foot.sx1, char.foot.sy1)
								love.graphics.line(-dx + char.x,-dy + char.y - char.legHeight- char.z,char.foot.sx2, char.foot.sy2)
							end
							love.graphics.setColor(1,1,1)
						end
					--else

						--love.graphics.line(dx + char.x,dy + char.y - char.legHeight,char.foot.sx1, char.foot.sy1)
						--love.graphics.line(-dx + char.x,-dy + char.y - char.legHeight,char.foot.sx2, char.foot.sy2)
					--end

					love.graphics.setColor(1,1,1)
					love.graphics.setLineWidth(1)


			end




		end
	end
end