

local drawables = {}
local added = false
function add_drawable(type,args)

	if(type == "img" or type == "blood") then
		local d = {}
		d.img = args.img
		d.type = type
		d.x = args.x
		d.y = args.y
		d.angle = args.angle
		d.sx = args.sx
		d.sy = args.sy
		d.ox = args.ox
		d.oy = args.oy
		d.height = args.height
		if(type == "blood") then
			d.alpha = args.alpha
		end
		table.insert(drawables, d)
	elseif(type == "rect") then
		local d = {}
		d.type = type
		d.x = args.x
		d.y = args.y
		d.w = args.w
		d.h = args.h
		d.height = args.height
		table.insert(drawables, d)
		added = true
	elseif(type == "line") then
		local d = {}
		d.type = type
		d.x1 = args.x1
		d.y1 = args.y1
		d.x2 = args.x2
		d.y2 = args.y2
		d.height = args.height
		d.width = args.width
		table.insert(drawables, d)
		added = true		
	end
end

function drawables_update(dt)

end

local lastDrawn = 0
local lastDrawnOnScreen = 0
function drawables_draw()
	for i=#drawables,1,-1 do
		local v = drawables[i]
		if(v.type == "line") then
			
		else
			if(on_screen(v.x,v.y,50,50) == false) then
				table.remove(drawables, i)
			end
		end
	end
	

	local sort = function(d1, d2)
		return d1.height < d2.height
	end

	table.sort(drawables, sort)

	for i,v in ipairs(drawables) do
		if(v.type == "img") then
			love.graphics.draw(v.img, v.x, v.y, v.angle, v.sx, v.sy, v.ox, v.oy)
		elseif(v.type == "blood") then
			love.graphics.setColor(0.5,0,0,v.alpha)
			love.graphics.draw(v.img, v.x, v.y, v.angle, v.sx, v.sy, v.ox, v.oy)
			love.graphics.setColor(1,1,1)
		elseif(v.type == "rect") then
			love.graphics.rectangle("fill",v.x,v.y,v.w,v.h)
		elseif(v.type == "line") then
			for i = 3,1,-1 do
				love.graphics.setColor(68/255 - i/3 * 0.25,68/255 - i/3 * 0.25,68/255 - i/3 * 0.25)
				love.graphics.setLineWidth(v.width * i/3)
				love.graphics.line(v.x1, v.y1, v.x2, v.y2)
				love.graphics.setColor(1,1,1)
			end
		end
	end
	
	
	love.graphics.setLineWidth(1)
	--[[
	lastDrawnOnScreen = 0
	for i,v in ipairs(drawables) do
		if(v.type == "line") then
			lastDrawnOnScreen = lastDrawnOnScreen + 1
		else
			if(on_screen(v.x,v.y,50,50)) then
				lastDrawnOnScreen = lastDrawnOnScreen + 1
			end
		end
	end
	]]--
	lastDrawn = #drawables
	drawables = {}
end

function drawables_ui()
	love.graphics.print(lastDrawn..", "..lastDrawnOnScreen,100,0)
end