
local enemies = {}
local moveSpeed = 140--140
function add_enemy(x, y)
	local en = {}
	
	en.x = x
	en.y = y
	en.xvel = 0
	en.yvel = 0
	en.angle = 0
	en.moveAngle = 0
	en.stopped = true
	en.char = new_char()
	en.attacking = true
	table.insert(enemies, en)
	get_char(en.char).team = 2
	set_charPos(en.char,x,y)
	anim_char(en.char, 2)

	local r = math.random(1,10)
	if(r == 1) then
		local char = get_char(en.char)
		char.team = 2
		char.weapon = 1
	end

end

local attackRange = 100
local stopRange = 30
local slowDownRange = 30

function enemies_update(dt)
	for i,v in ipairs(enemies) do
		local char = get_char(v.char)

		if(char) then
			v.x, v.y = get_charPos(v.char)

			local px, py = get_playerPos()
			

			local chasePlayer = true
			for i = 1, num_fountains() do
				local x,y, fade, active = get_fountain(i)
				if(active) then
					chasePlayer = false
					v.angle = math.atan2(v.y - y, v.x - x)
					v.xvel = math.cos(v.angle) * moveSpeed
					v.yvel = math.sin(v.angle) * moveSpeed
					v.moveAngle = v.angle

					move_char(v.char, v.angle, v.moveAngle, v.xvel, v.yvel)
				end
			end

			if(v.attacking) then
				if(char.attackPower == 0) then
					v.attacking = false
				end
			end

			local curMoveSpeed = moveSpeed

			if(chasePlayer and CheckCollision(v.x - attackRange, v.y - attackRange, attackRange * 2, attackRange *2, px,py,1,1)) then
			local dist = dist(px, py, v.x, v.y)
				if((dist < attackRange or v.attacking) and char.attackPower < 1) then
					v.attacking = true
					if(dist < slowDownRange) then
						curMoveSpeed = moveSpeed * math.max(0.25, (dist/slowDownRange))
					end
				end
			end

			if(chasePlayer and v.attacking and char.attackPower < 1) then
				attack_char(v.char)
			end			


			if(chasePlayer) then
				v.angle = math.atan2(py - v.y, px - v.x)
				v.xvel = math.cos(v.angle) * curMoveSpeed
				v.yvel = math.sin(v.angle) * curMoveSpeed
				v.moveAngle = v.angle

				move_char(v.char, v.angle, v.moveAngle, v.xvel, v.yvel)
			end

			if(char.active == false) then
				table.remove(enemies,i)
			end
		end
	end
end