
local perlin = love.filesystem.read("perlin2d.glsl")
local shader_code = perlin..[[
vec4 color1 = vec4(0.0,0.0,0.0,1.0);
extern vec2 offset = vec2(0.0, 0.0);
extern float timer = 0.0;
extern vec2 noise2Offset = vec2(500.0, 500.0);
extern vec2 noise1Offset = vec2(0.0, 0.0);
extern vec3 tintColour = vec3(0.0, 0.0, 0.0);
vec4 effect(vec4 color, Image image, vec2 uvs, vec2 screen_coords)
{

	vec4 pixel = Texel(image, uvs);
	float avg = (pixel.r + pixel.g + pixel.b)/3.0;
	float boost = 0.0;
	//avg = min(1, avg * boost);
	
	//return vec4(avg, avg, avg, pixel.a);
	
	//if(avg < 0.1)
	//{
		//float x = fract(sin(dot(st.xy, vec2(12.9898,78.233)))* 43758.5453123);	
		//float x = 0.1;
		//return vec4(x, x, x, 1.0);
		screen_coords = screen_coords + offset;
		
		//number noise = perlin2d(screen_coords / 128.0);
		number noise = perlin2d((screen_coords + noise1Offset) / 200.0); // was  / 180
		number noise2 = perlin2d((screen_coords + noise2Offset)/ 200.0);
		noise = noise * timer + noise2 * (1 - timer); 
		//noise = 1 - noise;
		noise = noise * 0.5 + 0.5;
		//noise = max(noise, 0.25);
		float c = noise * 0.1 * (1.0 - avg); // *0.075;
		
		//return vec4(1.0 - avg,1.0 - avg,1.0 - avg, 1.0);
		//return vec4(c, c*1.5, c, c);
		//return vec4(c*0.1, c*0.1, c, c);
		
		
		//return vec4(c*1.5, c, c*1.5, c); // purple
		//return vec4(c,c*2,c,c*2); // green
		//return vec4(c*0.75, c*0.75, c*1.75, c); // blue
		
		return vec4(c*tintColour[0],c*tintColour[1],c*tintColour[2],c*2); // green

	//}
	//else
	//{
		//return pixel;
	//}
}
]]



local shader = love.graphics.newShader(shader_code)
local fogCanvas = love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())
local timer = 0
local direction = 1
local smoothDirection = 1

local tcol = {0,0,0}
local col = {0,0,0}
local changeSpeed = 0.4

function fog_update(dt)
	
	-- smooth colour
	
	for i=1,3 do
		col[i] = col[i] + (tcol[i] - col[i]) * changeSpeed * dt
	end
	if(isAtFountain() == false) then
		tcol = {1,2,1}
	else
		tcol = {1.75,0.75,1.75}
	end		
	
	shader:send("tintColour", {col[1], col[2], col[3]})
	
	--
	
	smoothDirection = smoothDirection + (direction - smoothDirection) * dt
	timer = timer + dt * direction + timer * dt * direction
	if(timer > 1) then
		timer = 0.999
		direction = -1
		shader:send("noise2Offset", {math.random(-500,500), math.random(-500,500)})
	end
	
	if(timer < 0) then
		timer = 0.001
		shader:send("noise1Offset", {math.random(-500,500), math.random(-500,500)})
		direction = 1
	end

	local px, py = get_cam()
	px, py = px*4, py*4
	--px, py = px - timer, py - timer
	shader:send("offset", {px, py})
	
	--timer = timer + dt
	--timer = timer % 1
	shader:send("timer", timer)
end

function set_fog()
	love.graphics.setShader(shader)
end

function fog_resize()
	love.graphics.newCanvas(love.graphics.getWidth(), love.graphics.getHeight())
	love.graphics.setCanvas(fogCanvas)
	love.graphics.rectangle("fill", 0,0, love.graphics:getWidth(), love.graphics:getHeight())
	love.graphics.setCanvas()
end

fog_resize()

function fog_draw()
	--love.graphics.setShader(shader)
	--love.graphics.draw(fogCanvas)
	--love.graphics.setShader()
end