

local hitboxs = {}

function add_hitbox(team, x,y,angle,range,arc,power)
	local hb = {}
	hb.team = team
	hb.x = x
	hb.y = y
	hb.angle = angle
	hb.range = range
	hb.arc = arc
	hb.power = power
	table.insert(hitboxs, hb)
end

function hitbox_draw()

end

function check_hitboxs()
	for i,v in ipairs(hitboxs) do
		for j=1,num_chars() do
			local char = get_char(j)
			if(v.team ~= char.team and dist(v.x,v.y,char.x,char.y) < v.range) then
				local a = math.atan2(char.y - v.y, char.x - v.x)
				a = v.angle - a
				a = math.abs((a + math.pi) % (2*math.pi) - math.pi)
				if(a < v.arc/2) then
					dmg_char(j, v.x, v.y, v.power)
				end
			end
		end

		for j=1,num_physObj() do
			local p = get_physObj(j)
			if(p.zvel <= 0 and dist(v.x, v.y, p.x, p.y) < v.range) then
				local a = math.atan2(p.y - v.y, p.x - v.x)
				local a1 = a
				a = v.angle - a
				a = math.abs((a + math.pi) % (2*math.pi) - math.pi)
				if(a < v.arc/2) then
					play_sfx("bodyImpact",v.x,v.y)
				
					p.xvel = p.xvel + math.cos(a1) * v.power
					p.yvel = p.yvel + math.sin(a1) * v.power
					p.zvel = p.zvel + v.power
				end				
			end
		end
	end

	hitboxs = {}
end